#ifndef _CTYPE_H
#define _CTYPE_H

#include <bits/macros.h>

#ifdef __cplusplus
extern "C"
{
#endif

    /* Is this character alphanumeric? */
    int isalnum(int c);

    /* Is this character a letter? */
    int isalpha(int c);

    /* Is this character part of ASCII? */
    int isascii(int c);

    /* Is this character a blank character (space or tab)? */
    int isblank(int c);

    /* Is this character a control character? */
    int iscntrl(int c);

    /* Is this character a digit? */
    int isdigit(int c);

    /* Is this character any printable character except space? */
    int isgraph(int c);

    /* Is this character a lowercase letter? */
    int islower(int c);

    /* Is this character any printable character (including space)? */
    int isprint(int c);

    /* Is this character any printable character which is not a space or an alphanumeric character? */
    int ispunct(int c);

    /* Is this character any space character (space, form feed, newline, carriage return, tab, vertical tab)? */
    int isspace(int c);

    /* Is this character an uppercase letter? */
    int isupper(int c);

    /* Is this character a hexadecimal digit (0-9, a-f, A-F)? */
    int isxdigit(int c);

    /* Returns the lowercase form of the specified character. */
    int tolower(int c);

    /* Returns the uppercase form of the specified character. */
    int toupper(int c);

    /* Returns the character c, truncated to fit in the ASCII character set. This function should not be used, as it
     * will convert accented letters into random characters. */
    __lc_is_deprecated int toascii(int c);

#ifdef __cplusplus
}
#endif

#endif